# PRiME Framework

The PRiME Framework is a collection of software modules that support a novel API, specifically designed to enable the agnostic runtime management of software applications and hardware platforms.  

The aim is to make runtime management algorithms cross-platform and independent of the specific features of applications.
The scalability of this framework extends from embedded microcontrollers to heterogeneous many-core systems. 

The framework introduces the concept of exposing sources of control and monitoring from applications and platforms, in order to improve their coherence and increase system energy efficiency, relaibility and performance as a result.

See the [Wiki](https://github.com/PRiME-project/PRiME-Framework/wiki) for documentation on developing with the PRiME Framework.
For more information on developing for a particular module of the PRiME Framework, refer to the specific wiki page:  

[Application Developer Documentation](https://github.com/PRiME-project/PRiME-Framework/wiki/1-Application-Development)  
[RTM Developer Documentation](https://github.com/PRiME-project/PRiME-Framework/wiki/2-RTM-Development)  
[Device Developer Documentation](https://github.com/PRiME-project/PRiME-Framework/wiki/3-Device-Development)  
[UI Information](https://github.com/PRiME-project/PRiME-Framework/wiki/4-UI-Information)  
[Logger Information](https://github.com/PRiME-project/PRiME-Framework/wiki/5-Logger-Information)  
[Visualiser Information](https://github.com/PRiME-project/PRiME-Framework/wiki/6-Visualiser-Information) 


## Publications

Leech, C., Bragg, G. M., Balsamo, D.,  Wachter, E., Merrett, G. V. & Al-Hashimi, B. M. (2018) *Application Control and Monitoring in Heterogeneous Multiprocessor Systems*. 13th International Symposium on Reconfigurable Communication-centric Systems-on-Chip (ReCoSoC)

Bragg, G. M., Balsamo, D., Leech, C. & Merrett, G. V.. (2018) *The PRiME Framework: Application- & Platform-agnostic System Management*. Adaptive Many-Core Architectures and Systems Workshop, UK. 13 – 15 June 2018.

## License

GPL and lesser GPL
